scala.reflect.generic.UnPickler

# Scan

#### abstract class Scan extends PickleBuffer

Source
  UnPickler.scala

Linear Supertypes
PickleBuffer, AnyRef, Any
Ordering

1. Alphabetic
2. By inheritance

Inherited

1. Hide All
2. Show all

1. Scan
2. PickleBuffer
3. AnyRef
4. Any

Visibility

1. Public
2. All

### Instance Constructors

1. #### new Scan(bytes: Array[Byte], offset: Int, classRoot: Symbol, moduleRoot: Symbol, filename: String)

### Abstract Value Members

1. #### abstract def inferMethodAlternative(fun: Tree, argtpes: List[Type], restpe: Type): Unit

   pre: `fun` points to a symbol with an overloaded type.

   pre: `fun` points to a symbol with an overloaded type. Selects the overloaded alternative of `fun` which best matches given argument types `argtpes` and result type `restpe`. Stores this alternative as the symbol of `fun`.

2. #### abstract def newLazyTypeRef(i: Int): LazyType

   Create a lazy type which when completed returns type at index `i`.

3. #### abstract def newLazyTypeRefAndAlias(i: Int, j: Int): LazyType

   Create a lazy type which when completed returns type at index `i` and sets alias of completed symbol to symbol at index `j`

### Concrete Value Members

1. #### final def !=(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

2. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     Any

3. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types.

   Equivalent to `x.hashCode` except for boxed numeric types. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

4. #### final def ==(arg0: AnyRef): Boolean

   Definition Classes
     AnyRef

5. #### final def ==(arg0: Any): Boolean

   Test two objects for equality.

   Test two objects for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     Any

6. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown
     ClassCastException

     if the receiver object is not an instance of the erasure of type `T0`.

7. #### def at[T <: AnyRef](i: Int, op: () ⇒ T): T

   If entry at `i` is undefined, define it by performing operation `op` with `readIndex at start of i'th entry. Restore `readIndex` afterwards.`

   If entry at `i` is undefined, define it by performing operation `op` with `readIndex at start of i'th entry. Restore `readIndex` afterwards.`

   Attributes
     protected

8. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[lang]
   Definition Classes
     AnyRef
   Annotations
     @throws()
   Note

     not specified by SLS as a member of AnyRef

9. #### def createIndex: Array[Int]

   Pickle = majorVersion_Nat minorVersion_Nat nbEntries_Nat {Entry} Entry = type_Nat length_Nat [actual entries]

   Pickle = majorVersion_Nat minorVersion_Nat nbEntries_Nat {Entry} Entry = type_Nat length_Nat [actual entries]

   Assumes that the ..Version_Nat are already consumed.

   returns

     an array mapping entry numbers to locations in the byte array where the entries start.

   Definition Classes
     PickleBuffer

10. #### def debug: Boolean

    Attributes
      protected

11. #### def ensureCapacity(capacity: Int): Unit

    Definition Classes
      PickleBuffer

12. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

13. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. See equals in Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

14. #### def errorBadSignature(msg: String): Nothing

    Attributes
      protected

15. #### def errorMissingRequirement(name: Name, owner: Symbol): Nothing

    Attributes
      protected

16. #### def errorMissingRequirement(msg: String): Nothing

    Attributes
      protected

17. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[lang]
    Definition Classes
      AnyRef
    Annotations
      @throws()
    Note

      not specified by SLS as a member of AnyRef

18. #### final def getClass(): java.lang.Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

20. #### def isChildrenEntry(i: Int): Boolean

    Does the entry represent children of a symbol?

    Does the entry represent children of a symbol?

    Attributes
      protected

21. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

22. #### def isNameEntry(i: Int): Boolean

    Does entry represent a name?

    Does entry represent a name?

    Attributes
      protected

23. #### def isRefinementSymbolEntry(i: Int): Boolean

    Does entry represent a refinement symbol? pre: Entry is a class symbol

    Does entry represent a refinement symbol? pre: Entry is a class symbol

    Attributes
      protected

24. #### def isSymbolAnnotationEntry(i: Int): Boolean

    Does entry represent a symbol annotation?

    Does entry represent a symbol annotation?

    Attributes
      protected

25. #### def isSymbolEntry(i: Int): Boolean

    Does entry represent an (internal) symbol

    Does entry represent an (internal) symbol

    Attributes
      protected

26. #### def isSymbolRef(i: Int): Boolean

    Does entry represent an (internal or external) symbol

    Does entry represent an (internal or external) symbol

    Attributes
      protected

27. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

28. #### def noSuchConstantTag(tag: Int, len: Int): Constant

29. #### def noSuchTreeTag(tag: Int, end: Int): Nothing

30. #### def noSuchTypeTag(tag: Int, end: Int): Type

31. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

32. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

33. #### def patchNat(pos: Int, x: Int): Unit

    Write a natural number `x` at position `pos`.

    Write a natural number `x` at position `pos`. If number is more than one byte, shift rest of array to make space.

    pos

      ...

    x

      ...

    Definition Classes
      PickleBuffer

34. #### def peekByte(): Int

    Peek at the current byte without moving the read index

    Peek at the current byte without moving the read index

    Definition Classes
      PickleBuffer

35. #### def readAnnotArg(i: Int): Tree

    Read an annotation argument, which is pickled either as a Constant or a Tree.

    Read an annotation argument, which is pickled either as a Constant or a Tree.

    Attributes
      protected

36. #### def readAnnotation(): AnnotationInfo

    Read an annotation and return it.

    Read an annotation and return it. Used when unpickling an ANNOTATED(WSELF)tpe or a NestedAnnotArg

    Attributes
      protected

37. #### def readAnnotationInfo(end: Int): AnnotationInfo

    Read an AnnotationInfo.

    Read an AnnotationInfo. Not to be called directly, use readAnnotation or readSymbolAnnotation

    Attributes
      protected

38. #### def readAnnotationRef(): AnnotationInfo

    Attributes
      protected

39. #### def readByte(): Int

    Read a byte

    Read a byte

    Definition Classes
      PickleBuffer

40. #### def readCaseDefRef(): CaseDef

    Attributes
      protected

41. #### def readChildren(): Unit

    Read children and store them into the corresponding symbol.

    Read children and store them into the corresponding symbol.

    Attributes
      protected

42. #### def readClassfileAnnotArg(i: Int): ClassfileAnnotArg

    Attributes
      protected

43. #### def readConstant(): Constant

    Read a constant

    Read a constant

    Attributes
      protected

44. #### def readConstantRef(): Constant

    Attributes
      protected

45. #### def readIdentRef(): Ident

    Attributes
      protected

46. #### var readIndex: Int

    Definition Classes
      PickleBuffer

47. #### def readLong(len: Int): Long

    Read a long number in signed big endian format, base 256.

    Read a long number in signed big endian format, base 256.

    Definition Classes
      PickleBuffer

48. #### def readLongNat(): Long

    Definition Classes
      PickleBuffer

49. #### def readModifiers(): Modifiers

50. #### def readModifiersRef(): Modifiers

    Attributes
      protected

51. #### def readName(): Name

    Read a name

    Read a name

    Attributes
      protected

52. #### def readNameRef(): Name

    Attributes
      protected

53. #### def readNat(): Int

    Read a natural number in big endian format, base 128.

    Read a natural number in big endian format, base 128. All but the last digits have bit 0x80 set.

    Definition Classes
      PickleBuffer

54. #### def readSymbol(): Symbol

    Read a symbol

    Read a symbol

    Attributes
      protected

55. #### def readSymbolAnnotation(): Unit

    Read an annotation and as a side effect store it into the symbol it requests.

    Read an annotation and as a side effect store it into the symbol it requests. Called at top-level, for all (symbol, annotInfo) entries.

    Attributes
      protected

56. #### def readSymbolRef(): Symbol

    Attributes
      protected

57. #### def readTemplateRef(): Template

    Attributes
      protected

58. #### def readTermNameRef(): TermName

    Attributes
      protected

59. #### def readTree(): Tree

    Attributes
      protected

60. #### def readTreeRef(): Tree

    Attributes
      protected

61. #### def readType(forceProperType: Boolean = false): Type

    Read a type

    Read a type

    forceProperType

      is used to ease the transition to NullaryMethodTypes (commentmarker: NMT_TRANSITION) the flag say that a type of kind * is expected, so that PolyType(tps, restpe) can be disambiguated to PolyType(tps, NullaryMethodType(restpe)) (if restpe is not a ClassInfoType, a MethodType or a NullaryMethodType, which leaves TypeRef/SingletonType -- the latter would make the polytype a type constructor)

    Attributes
      protected

62. #### def readTypeDefRef(): TypeDef

    Attributes
      protected

63. #### def readTypeNameRef(): TypeName

    Attributes
      protected

64. #### def readTypeRef(): Type

    Attributes
      protected

65. #### def readValDefRef(): ValDef

    Attributes
      protected

66. #### def run(): Unit

67. #### def symScope(sym: Symbol): Scope

    The `decls' scope associated with given symbol`

    The `decls' scope associated with given symbol`

    Attributes
      protected

68. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

69. #### def times[T](n: Int, op: () ⇒ T): List[T]

    Perform operation `op` the number of times specified.

    Perform operation `op` the number of times specified. Concatenate the results into a list.

    Definition Classes
      PickleBuffer

70. #### def toIndexedSeq: IndexedSeq[(Int, Array[Byte])]

    Returns the buffer as a sequence of (Int, Array[Byte]) representing (tag, data) of the individual entries.

    Returns the buffer as a sequence of (Int, Array[Byte]) representing (tag, data) of the individual entries. Saves and restores buffer state.

    Definition Classes
      PickleBuffer

71. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

72. #### def until[T](end: Int, op: () ⇒ T): List[T]

    Perform operation `op` until the condition `readIndex == end` is satisfied.

    Perform operation `op` until the condition `readIndex == end` is satisfied. Concatenate results into a list.

    end

      ...

    op

      ...

    returns

      ...

    Definition Classes
      PickleBuffer

73. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

74. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

75. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws()

76. #### def writeByte(b: Int): Unit

    Write a byte of data

    Write a byte of data

    Definition Classes
      PickleBuffer

77. #### var writeIndex: Int

    Definition Classes
      PickleBuffer

78. #### def writeLong(x: Long): Unit

    Write a long number `x` in signed big endian format, base 256.

    Write a long number `x` in signed big endian format, base 256.

    x

      The long number to be written.

    Definition Classes
      PickleBuffer

79. #### def writeLongNat(x: Long): Unit

    Like writeNat, but for longs.

    Like writeNat, but for longs. This is not the same as writeLong, which writes in base 256. Note that the binary representation of LongNat is identical to Nat if the long value is in the range Int.MIN_VALUE to Int.MAX_VALUE.

    Definition Classes
      PickleBuffer

80. #### def writeNat(x: Int): Unit

    Write a natural number in big endian format, base 128.

    Write a natural number in big endian format, base 128. All but the last digits have bit 0x80 set.

    Definition Classes
      PickleBuffer

### Inherited from PickleBuffer

### Inherited from AnyRef

### Inherited from Any